# gcp::Molecule Class Reference

GChemPaint molecule class. More...

`#include <gcp/molecule.h>`

Inheritance diagram for gcp::Molecule:

List of all members.

## Public Member Functions

| Molecule (gcu::TypeId Type=gcu::MoleculeType)
| Molecule (Atom *pAtom)
virtual | ~Molecule ()
void | AddChild (gcu::Object *object)
void | AddAtom (gcu::Atom *pAtom)
void | AddFragment (Fragment *pFragment)
void | AddBond (gcu::Bond *pBond)
void | Add (GtkWidget *w) const
void | Remove (gcu::Object *pObject)
bool | Merge (Molecule *pMolecule, bool RemoveDuplicates=false)
bool | Load (xmlNodePtr node)
xmlNodePtr | Save (xmlDocPtr xml) const
void | Clear ()
void | Transform2D (gcu::Matrix2D &m, double x, double y)
Object * | GetAtomAt (double x, double y, double z=0.)
double | GetYAlign ()
bool | BuildContextualMenu (GtkUIManager *UIManager, gcu::Object *object, double x, double y)
bool | OnSignal (gcu::SignalId Signal, gcu::Object *Child)
void | ExportToGhemical ()
void | SelectAlignmentItem (gcu::Object *child)
std::string | GetAlignmentId ()
void | BuildOBMol (OpenBabel::OBMol &Mol)
void | BuildOBMol2D (OpenBabel::OBMol &Mol)
void | ShowInChI ()
void | BuildInChI ()
void | BuildSMILES ()
void | ShowWebBase (char const *uri_start, char const *uri_end)
void | OpenCalc ()
void | CheckCrossings (Bond *pBond)
char const * | GetInChI ()
std::string | GetRawFormula () const
void | OnLoaded ()
unsigned | GetAtomsNumber () const

## Detailed Description

GChemPaint molecule class.

Definition at line 41 of file gcp/molecule.h.

## Constructor & Destructor Documentation

gcp::Molecule::Molecule | ( | gcu::TypeId | Type = `gcu::MoleculeType` | ) |

The default constructor. Builds a new empty molecule.

Reimplemented from gcu::Molecule.

gcp::Molecule::Molecule | ( | Atom * | pAtom | ) |

Parameters:

  | pAtom | an atom.

Constructs a new molecule containing pAtom and all atoms which might be bonded to it, and the corresponding bonds.

virtual gcp::Molecule::~Molecule | ( |  | ) | `[virtual]`

The destructor.

Reimplemented from gcu::Molecule.

## Member Function Documentation

void gcp::Molecule::AddChild | ( | gcu::Object * | object | ) | `[virtual]`

Parameters:

  | object | the object to add to the molecule.

Adds an object (atom, bond, or fragment) to the molecule.

Reimplemented from gcu::Molecule.

void gcp::Molecule::AddAtom | ( | gcu::Atom * | pAtom | ) | `[virtual]`

Parameters:

  | pAtom | an atom.

Adds an atom to the molecule.

Reimplemented from gcu::Molecule.

void gcp::Molecule::AddFragment | ( | Fragment * | pFragment | ) |

Parameters:

  | pFragment | an atoms group.

Adds a fragment to the molecule.

void gcp::Molecule::AddBond | ( | gcu::Bond * | pBond | ) | `[virtual]`

Parameters:

  | pBond | a bond.

Adds a bond to the molecule.

Reimplemented from gcu::Molecule.

void gcp::Molecule::Add | ( | GtkWidget * | w | ) | const`[virtual]`

Parameters:

  | w | the GtkWidget inside which the molecule will be displayed.

Used to add a representation of the molecule in the widget. It just calls the method for all its children.

Reimplemented from gcu::Object.

void gcp::Molecule::Remove | ( | gcu::Object * | pObject | ) | `[virtual]`

Parameters:

  | pObject | an atom, a bond, or a fragment in the molecule.

Removes an atom, a bond, or a fragment from a molecule.

Reimplemented from gcu::Molecule.

bool gcp::Molecule::Merge | ( | Molecule * | pMolecule,
|  | bool | RemoveDuplicates = `false` |
| ) |  |  |

Parameters:

  | pMolecule | a molecule.
  | RemoveDuplicates | whether duplicate atoms should be unififed or not.

Adds all children from pMolecule in this instance, and removes one of the atoms for each pair of duplicates (atoms with same atomic number and position) if RemoveDuplicates is true. This might fail when it would end with hypervalent atoms. On success pMolecule is deleted.

Returns:
  true on success, false otherwise.

bool gcp::Molecule::Load | ( | xmlNodePtr | node | ) | `[virtual]`

Parameters:

  | node | a pointer to the xmlNode containing the serialized molecule.

Used to load a molecule in memory. The Mlecule instance must already exist.

Returns:
  true on succes, false otherwise.

Reimplemented from gcu::Object.

xmlNodePtr gcp::Molecule::Save | ( | xmlDocPtr | xml | ) | const`[virtual]`

Parameters:

  | xml | the xmlDoc used to save the document.

Used to save the molecule to the xmlDoc.

Returns:
  the xmlNode containing the serialized molecule.

Reimplemented from gcu::Object.

void gcp::Molecule::Clear | ( |  | ) |

Removes all children from the molecule, resulting in a empty molecule.

void gcp::Molecule::Transform2D | ( | gcu::Matrix2D & | m,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | m | the Matrix2D of the transformation.
  | x | the x component of the center of the transformation.
  | y | the y component of the center of the transformation.

Used to move and/or transform the molecule taking care of hydrogen atoms positions around heteroatoms.

Reimplemented from gcu::Object.

Object* gcp::Molecule::GetAtomAt | ( | double | x,
|  | double | y,
|  | double | z = `0.` |
| ) |  |  | `[virtual]`

Parameters:

  | x | the x coordinate
  | y | the y coordinate
  | z | the z coordinate (not used)

Returns:
  a pointer to n atom at or near position defined by the coordinates passed as parameters or NULL if none is found in the molecule.

Reimplemented from gcu::Object.

double gcp::Molecule::GetYAlign | ( |  | ) | `[virtual]`

Used to retrieve the y coordinate for alignment.

Returns:
  y coordinate used for the molecule alignment.

Reimplemented from gcu::Object.

bool gcp::Molecule::BuildContextualMenu | ( | GtkUIManager * | UIManager,
|  | gcu::Object * | object,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | UIManager | the GtkUIManager to populate.
  | object | the Object on which occured the mouse click.
  | x | x coordinate of the mouse click.
  | y | y coordinate of the mouse click.

This method is called to build the contextual menu for the molecule.

Returns:
  true if something is added to the UIManager, false otherwise.

Reimplemented from gcu::Object.

bool gcp::Molecule::OnSignal | ( | gcu::SignalId | Signal,
|  | gcu::Object * | Child |
| ) |  |  | `[virtual]`

Parameters:

  | Signal | the appropriate SignalId
  | Child | the child which emitted the signal or NULL

Signals the molecule that at least one of its children changed.

Returns:
  true to propagate the signal to the parent.

Reimplemented from gcu::Object.

void gcp::Molecule::ExportToGhemical | ( |  | ) |

Opens a Ghemical window with a copy of the molecule trying to preserve the stereochemistry as far as possible.

void gcp::Molecule::SelectAlignmentItem | ( | gcu::Object * | child | ) |

Parameters:

  | child | the child used for alignment.

Selects the child used for alignment, which might be an atom or group of atoms, or a bond. For bonds, the center of the bonds is used, a while for the others a call to their gcu::Object::GetYAlign() method will be used.

std::string gcp::Molecule::GetAlignmentId | ( |  | ) | `[inline]`

Returns:
  the id string of the child used for alignment if any, or an empty string.

Definition at line 183 of file gcp/molecule.h.

References gcu::Object::GetId().

void gcp::Molecule::BuildOBMol | ( | OpenBabel::OBMol & | Mol | ) |

Parameters:

  | Mol | the OpenBabel molecule used for export.

Builds an OpenBabel molecule from this instance. The new molecule is built trying to guess appropriate z coordinates so that stereochemistry is preserved.

void gcp::Molecule::BuildOBMol2D | ( | OpenBabel::OBMol & | Mol | ) |

Parameters:

  | Mol | the OpenBabel molecule used for export.

Builds a 2D OpenBabel molecule from this instance.

void gcp::Molecule::ShowInChI | ( |  | ) |

Builds the InChI for the molecule if necessary and opens a new StringDlg instance displaying it.

void gcp::Molecule::BuildInChI | ( |  | ) |

Builds the InChI for the molecule.

void gcp::Molecule::BuildSMILES | ( |  | ) |

Builds the SMILES representation for the molecule and opens a new StringDlg instance displaying it.

void gcp::Molecule::ShowWebBase | ( | char const * | uri_start,
|  | char const * | uri_end |
| ) |  |  |

Parameters:

  | uri_start | the first part of the URI to open.
  | uri_end | the last part of the URI to open.

Opens a web browser with an URI constructed from both arguments and the InChI for the molecule ntercalated between uri_start and uri_end.

void gcp::Molecule::OpenCalc | ( |  | ) |

Opens GChemCalc with the formula for the molecule. Molecules with fragments are not currently supported.

void gcp::Molecule::CheckCrossings | ( | Bond * | pBond | ) |

Parameters:

  | pBond | a bond in the molecule.

Checks if any other bond in the molecule crosses pBond, and notify both bonds that they are crossing.

char const* gcp::Molecule::GetInChI | ( |  | ) |

Returns:
  the InChI. The returned string should not be freed (it's a const char*). Molecules with fragments are not currently supported.

std::string gcp::Molecule::GetRawFormula | ( |  | ) | const

Returns:
  the raw formula as a string. Molecules with fragments are not currently supported.

void gcp::Molecule::OnLoaded | ( |  | ) | `[virtual]`

Updates all cycles after loading.

Reimplemented from gcu::Object.

unsigned gcp::Molecule::GetAtomsNumber | ( |  | ) | const`[virtual]`

Returns:
  the number of atoms in the molecule. Atoms groups are counted for one only, whatever their real atomic composition.

Reimplemented from gcu::Molecule.

The documentation for this class was generated from the following file:

- gcp/molecule.h